# SPDX-FileCopyrightText: 2020 Tocqueville Group
#
# SPDX-License-Identifier: LicenseRef-MIT-TQ

spec-version: 0.31.0

verbatim:
  cabal-version: 2.2

name:                example-lorentz-autodoc
version:             0.1
synopsis:            Example of introducing autodoc to a Lorentz contract
author:              Serokell, Tocqueville Group
copyright:           2020 Tocqueville Group
category:            Language,
extra-source-files:
  - README.md

description:         Please see the README on GitHub at <https://github.com/serokell/xrefcheck#readme>

default-extensions:
  - AllowAmbiguousTypes
  - BangPatterns
  - ConstraintKinds
  - DataKinds
  - DefaultSignatures
  - DeriveAnyClass
  - DeriveDataTypeable
  - DeriveGeneric
  - DerivingStrategies
  - FlexibleContexts
  - FlexibleInstances
  - FunctionalDependencies
  - GeneralizedNewtypeDeriving
  - LambdaCase
  - MultiParamTypeClasses
  - MultiWayIf
  - NamedFieldPuns
  - OverloadedStrings
  - OverloadedLabels
  - RankNTypes
  - RecordWildCards
  - ScopedTypeVariables
  - StandaloneDeriving
  - TemplateHaskell
  - TupleSections
  - TypeFamilies
  - UndecidableInstances
  - ViewPatterns
  - TypeApplications
  - TypeOperators
  - QuasiQuotes

ghc-options:
  - -Weverything
  - -Wno-missing-exported-signatures
  - -Wno-missing-import-lists
  - -Wno-missed-specialisations
  - -Wno-all-missed-specialisations
  - -Wno-unsafe
  - -Wno-safe
  - -Wno-missing-local-signatures
  - -Wno-monomorphism-restriction
  - -Wno-implicit-prelude

dependencies:
  - base-noprelude
  - morley
  - morley-prelude
  - lorentz

library:
  source-dirs: src

  generated-other-modules:
    - Paths_example_lorentz_autodoc

  default-extensions:
    - RebindableSyntax
    - NoApplicativeDo

  ghc-options:
    - -Wno-unused-do-bind

  dependencies:
    - fmt

executables:
  example-lorentz-autodoc-exec:
    main: Main.hs
    source-dirs: exec

    generated-other-modules:
      - Paths_example_lorentz_autodoc

    ghc-options:
      - -threaded
      - -rtsopts
      - -with-rtsopts=-N
      - -O2

    dependencies:
      - example-lorentz-autodoc
      - with-utf8

tests:
  example-lorentz-autodoc-test:

    main: Main.hs
    source-dirs: test
    build-tools: tasty-discover:tasty-discover

    ghc-options:
      - -threaded
      - -eventlog
      - -rtsopts

    dependencies:
      - cleveland
      - example-lorentz-autodoc
      - tasty
      - tasty-hunit-compat
